; File:     Combo14.asm
; by:       Rui Loureiro
;===============================================================================================
;                           Ficheiros inc / GLB
;-----------------------------------------------------------------------------------------------
                            include Combo14.inc

DialogWnd         proto    :DWORD,:DWORD,:DWORD,:DWORD

ComboEXSetup      proto    :DWORD,:DWORD
MovRclCBEX        proto    :DWORD
AddTblCBEX        proto    :DWORD
LookRegCBEX       proto    :DWORD,:DWORD
LookRclCBEX       proto    :DWORD
CopyRegCBEX       proto    :DWORD,:DWORD
CopyRclCBEX       proto    :DWORD
ClnRgtDos		proto    :DWORD,:DWORD


COMBOSTYLE1    equ WS_CHILD+WS_VISIBLE+WS_VSCROLL+CBS_DROPDOWNLIST+CBS_AUTOHSCROLL+CBS_NOINTEGRALHEIGHT
COMBOSTYLE2    equ WS_CHILD+WS_VISIBLE+WS_VSCROLL+CBS_DROPDOWN  or CBS_AUTOHSCROLL+CBS_NOINTEGRALHEIGHT

COMBOBOXEX1 macro x, y, dx, dy, ID
            invoke CreateWindowEx, 0, addr _CombBoxClas32, NULL, COMBOSTYLE1,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox1, eax
            invoke  GetStockObject, DEFAULT_GUI_FONT
            invoke  SendMessage, _hComboBox1, WM_SETFONT, eax,1
ENDM

COMBOBOXEX2 macro x, y, dx, dy, ID
            invoke CreateWindowEx, 0, addr _CombBoxClas32, NULL, COMBOSTYLE2,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox2, eax
            
            invoke  GetStockObject, DEFAULT_GUI_FONT
            invoke  SendMessage, _hComboBox2, WM_SETFONT, eax,1
ENDM

FONTCOMBO       macro
                invoke  GetStockObject, DEFAULT_GUI_FONT
                invoke  SendMessage, _hComboBox, WM_SETFONT, eax,1
ENDM
;-----------------------------------------------
COMBONOTIFY2    macro

                mov     ebx, lParam             
                mov     eax, [ebx + CB_hwndFrom]
                cmp     eax, _hComboBox2
                jne     _Edit

                mov     eax, [ebx + CB_code]
                cmp     eax, CBEN_BEGINEDIT
                je      _Edit                                   ; return 0 to allow edit

                cmp     eax, CBEN_ENDEDIT                       ; NMCBEENDEDIT structure !
                jne     _Abort                                  ; be sure to understand that !

                cmp     dword ptr [ebx + CB_fChanged], 0        ; fChanged, 0=unchanged
                je      _Abort                                  ; return 1 to abort edit
                                
                ;##################################
                invoke  MessageBeep, MB_ICONASTERISK
                ;##################################
                mov     eax, dword ptr [ebx + CB_iNewSelection]
                mov     _ComboItem2, eax
    
                add     ebx, CB_szText                           ; points to string
                mov     _cbex.pszText,ebx                        ; pointer to new item text

                call    MoveStrCBEX
                jc      short _Edit
                
                mov     _cbex._mask, CBEIF_TEXT                  ; insert new item
                mov     _cbex.iItem, -1                          ; at end of list
                invoke  SendMessage,_hComboBox2, CBEM_INSERTITEM, 0, ADDR _cbex

_Edit:          mov     eax, 0                                  ; return 0 to allow edit
                ret
                ;
                ; abort
                ; -----
_Abort:         mov     eax, 1
                ret 
ENDM
;-----------------------------------------------
DIALOGBOX         MACRO  Name, Proc
    invoke  DialogBoxParam, _hInstance, addr Name, _hWnd, addr Proc, 0 
ENDM
;===============================================================================================
;                           Constantes e Estruturas
;----------------------------------------------------------------------------------------------
.const
IDC_NEWDIS1     equ 4000
                 

MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL
MAIN_EXTSTYLE    equ 300h
$ECRAWIDTH       equ 600
$ECRAHEIGHT      equ 300  
;  Data Section 
.data
;--------------------------------------------------------
align 4
_ComboBoxClass  db "COMBOBOX",0
_CombBoxClas32  db "ComboBoxEx32",0

_hComboBox1     dd 0
_ComboItem1     dd 0
_hComboBox2     dd 0
_ComboItem2     dd 0
;....................................................................................
_IconName       db 'TDIcon', 0
_MenuName       db 'Menu',0        ; Definido em rsrc.rc
_ClassName      db 'WinClass',0
_WindowName     db 'ComboBoxEx 1',0
_AlteraDis      db "AlteraDis", 0
; ----------------------------------------------------------------------------------------------
                dd 20
                dd 7
_Heading1       db 'Produto'
                db 14 dup (0)
              
                dd 6
_String1        db "Item 1",0
                dd 6
_String2        db "Item 2",0
                dd 6
_String3        db "Item 3",0
                dd 6
_String4        db "Item 4",0
                dd 9
_String5        db "Item five",0
                dd 8
_String6        db "Item six",0
                dd 18
_String7        db "Item seven bla bla",0

                dd 7
_TblString      dd offset _String1
                dd offset _String2
                dd offset _String3
                dd offset _String4
                dd offset _String5
                dd offset _String6
                dd offset _String7

;------------------------------------
MAXSTRLENCBEX     equ 20
REGLENCBEX        equ MAXSTRLENCBEX + 5 
MAXCBEXPTRS       equ 100

MAXBUFCBEX        equ MAXCBEXPTRS * REGLENCBEX

                  dd REGLENCBEX                 ; -12 comprimento dos registos
                  dd MAXCBEXPTRS                ; -8  n mximo de ponteiros
                  dd 0                          ; -4  n de ponteiros
_BufferStrCBEX    db MAXBUFCBEX dup (0) 
                  dd 0
                  dd 0
;  Data? Section 
.data?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>
_x           dd ?
_y           dd ?

_icce        INITCOMMONCONTROLSEX <?>
_hInstance   dd ?
_hWnd        dd ?
_hdc         dd ?
_CaseChoose  dd ?

_cbex        COMBOBOXEXITEM <?>

;NMCBEENDEDIT  equ NMCBEENDEDITW  not defined in Windows.inc

; **********************
; NMCBEENDEDIT structure ( CBEMAXSTRLEN equ 260 )
; **********************
CB_hwndFrom         equ 0   ; window handle
CB_idFrom           equ 4
CB_code             equ 8
CB_fChanged         equ 12  ; 0=unchanged
CB_iNewSelection    equ 16  ; Zero-based index of the item that will be selected after 
                            ; completing the edit operation
CB_szText           equ 20  ;(lenmax= CBEMAXSTRLEN)
CB_iWhy             equ CB_szText + CBEMAXSTRLEN
;------------------------
_hComboEdit  dd ?
_OldEditProc dd ?
;  Code Section 
.code
;---------------------------------------
start:      invoke    GetModuleHandle, NULL
            mov       _hInstance, eax

            mov       _icce.dwSize, sizeof INITCOMMONCONTROLSEX
            mov       _icce.dwICC, ICC_USEREX_CLASSES or ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES


            invoke    InitCommonControlsEx, ADDR _icce    

            invoke    WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
; ##############################################################
align 16
WinMain     proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
            
            ; Window size and coordinates to center it on the screen
            ;-------------------------------------------------------
            invoke  GetSystemMetrics, SM_CXSCREEN
            sub     eax, $ECRAWIDTH
            shr     eax, 1
            mov     _x, eax
            invoke  GetSystemMetrics, SM_CXSCREEN
            sub     eax, $ECRAHEIGHT
            shr     eax, 1
            sub     eax, 80
            mov     _y, eax

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
        	mov   _wcx.hbrBackground, COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            invoke LoadIcon, hInst, offset _IconName     
            mov    _wcx.hIcon, eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela: WS_HSCROLL or WS_VSCROLL	
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   _x, _y, $ECRAWIDTH, $ECRAHEIGHT, 
                                   NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     
            
            invoke    GetDC, _hWnd
            mov       _hdc, eax

            ;
            ; Add strings from table to _BufferStrCBEX
            ; 
            invoke  AddTblCBEX, addr _TblString


            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd           
;################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
; process menuitems
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu0_1                                       

                    DIALOGBOX _AlteraDis, DialogWnd
                                            
                case    IDM_SAIR                                       

                    invoke    SendMessage, hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                ;cmp     eax, WM_CREATE
                ;je      _WM_CREATE
                                
                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND

; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE::    
                jmp        _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
; 
align 16
DialogWnd        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

             SWITCH  uMsg
             CASE    WM_INITDIALOG

                COMBOBOXEX2 178, 146, 160, 200, 200h
                call    ComboBoxExSetup

                invoke   SetDlgItemText, hWnd, IDC_NEWDIS1, addr _Heading1
                invoke   GetDlgItem, hWnd, IDC_NEWDIS1
                mov      ebx, eax
                invoke   GetStockObject, DEFAULT_GUI_FONT
                invoke   SendMessage, ebx, WM_SETFONT, eax,1
		    invoke   SetFocus, ebx

                mov     eax, TRUE
	          ret
                
             CASE    WM_CLOSE
                
_Quit:          invoke   EndDialog, hWnd, 0

                mov     eax, TRUE
	          ret
;.............................................................
             CASE    WM_NOTIFY

                COMBONOTIFY2

;.............................................................
             CASE    WM_COMMAND

;------------------ComboBox--------------------------
                mov     eax, lParam
                cmp     eax, _hComboBox2
                jne     _next
                ;
                mov     edx, wParam
                shr     edx, 16
                switch  edx
                    case    CBN_SELCHANGE

                        invoke SendMessage, _hComboBox2, CB_GETCURSEL, 0 ,0
                        cmp    eax, CB_ERR
                        je     short @F

                        mov     _ComboItem2, eax
                        
                        invoke  CopyRclCBEX, addr _Heading1
                        invoke  MessageBeep, MB_ICONASTERISK

                        invoke   SetDlgItemText, hWnd, IDC_NEWDIS1, addr _Heading1

@@:
                endsw
;------------------ComboBox-FIM-------------------------
_next:
                switch  wParam
                    case    IDC_CANCELA
                    
                        mov     _CaseChoose, 0
                        jmp     _Quit
;.......................................................
                endsw
             ENDSW

_exit:          mov     eax, FALSE
		    ret
DialogWnd       endp
; 
                            include ComboBox.asm
; ###################################################
    end     start
